package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.RadioButton;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.xml.client.DOMException;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NodeList;
import com.google.gwt.xml.client.XMLParser;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;
import java.util.ArrayList;

/**
   ץȺѥͥǤ
*/
public class NewProjectPanel extends SubPanel {

    /** ꥭ󥻥γǧå */
    private static final String CANCEL_CONFIRMATION
        = "You are about to cancel without saving changes. "
	+ "Are you sure you want to continue?";

    /** ƥȥܥåΥꥹ */
    private ArrayList<TextBoxPanel> boxes;

    /** 󥻥ܥ */
    private Button cancelButton;

    /** ܥ */
    private Button createButton;

    /** ̤ΥץȤ饳ԡΥ饸ܥΥ٥ */
    private HTML cloneLabel;

    /** ץID */
    private ListBox choice;

    /** ʥӥ */
    private Navigation navi;

    /** createProjectΥꥯȥå */
    private RequestKit kit;

    /** listProjectsꥯȥå */
    private RequestKit listKit;

    /** listProjectsΥꥯȥꥹ */
    private RequestListener loadedListener;

    /** createProjectΥꥯȥꥹ */
    private RequestListener submittedListener;

    /** ץȤID */
    private TextBoxPanel projectId;

    /** ѰդΥ饸ܥ */
    private RadioButton empty;

    /** ̤ΥץȤ饳ԡΥ饸ܥ */
    private RadioButton clone;

    /**
       ץȺѥͥޤ
    */
    public NewProjectPanel() {
	navi = new Navigation("New Project");
	navi.setLink(new Link("newProject"));

	projectId = new TextBoxPanel("Project ID", 40);

        boxes = new ArrayList<TextBoxPanel>();
	boxes.add(projectId);

	choice = new ListBox();
	choice.setVisibleItemCount(1);
	empty = new RadioButton("config");
	empty.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		choice.setEnabled(false);
	    }
	});
	clone = new RadioButton("config");
	clone.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		choice.setEnabled(true);
	    }
	});
	cloneLabel = new HTML("Copied from another project:");
	FlexTable table = new FlexTable();
	table.insertRow(0);
	table.setWidget(0, 0, empty);
	table.setText(0, 1, "Empty");
	table.insertRow(1);
	table.setWidget(1, 0, clone);
	table.setWidget(1, 1, cloneLabel);
	table.insertRow(2);
	table.setWidget(2, 1, choice);

	cancelButton = new Button("Cancel");
	cancelButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		cancelCreate();
	    }
	});

	createButton = new Button("Create");
	createButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		submit();
	    }
	});

	HorizontalPanel cp = new HorizontalPanel();
	HTML space = new HTML("&nbsp;");
	cp.add(cancelButton);
	cp.add(space);
	cp.add(createButton);
	cp.setCellWidth(space, "100%");
	cp.setWidth("100%");

	add(projectId);
	add(new HTML("&nbsp;"));
        add(new HTML("Initial Configuration"));
	add(table);
	add(new HTML("&nbsp;"));
        add(cp);

	setWidth("100%");

	listKit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		setVisibleTemplate(false);
	    }
	    public void stopRequest() {
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		parseListProjectsResponse(res.getText());
		if (choice.getItemCount() == 0) {
		    return;
		}
		setVisibleTemplate(true);
		choice.setSelectedIndex(0);
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
	    }
	};
	kit = new RequestKit();
        submittedListener = new RequestListener() {
	    public void startRequest() {
		MadAngler.setLoading(true);
		cancelButton.setEnabled(false);
		createButton.setEnabled(false);
		setTextEnabled(false);
	    }
	    public void stopRequest() {
		MadAngler.setLoading(false);
		cancelButton.setEnabled(true);
		createButton.setEnabled(true);
		setTextEnabled(true);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		Status s = new Status(res.getText());
		if (s.getCode() < 0) {
		    MadAngler.alert(s.getMessage());
		    return;
		}
		String template = null;
		if (clone.isChecked()) {
		    template = choice.getItemText(choice.getSelectedIndex());
		}
		notifySubmitted(projectId.getText(), template);
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
		notifyCanceled();
	    }
	};

    }

    /**
       ץȺߤޤ
    */
    private void cancelCreate() {
	if (navigationClicked()) {
	    notifyCanceled();
	}
    }

    /**
       ץȺꤷޤ
    */
    private void submit() {
	kit.cancel();
	Parameters params = new Parameters();
	params.add("method", "createProject");
	params.add("projectId", projectId.getText());
	kit.sendRequest(params.toString(), submittedListener);
    }

    /**
       ٤ƤΥƥȥܥåǽǽꤷޤ

       @param enabled trueǽfalseǽ
    */
    private void setTextEnabled(final boolean enabled) {
	for (int k = 0; k < boxes.size(); ++k) {
            TextBoxPanel box = boxes.get(k);
            box.setEnabled(enabled);
        }
    }

    /**
       ٤ƤΥƥȤˤޤ
    */
    private void clearText() {
	for (int k = 0; k < boxes.size(); ++k) {
            TextBoxPanel box = boxes.get(k);
            box.setText("");
        }
    }

    /**
       ơ֥Ρ¾ΥץȤ򥳥ԡʬβĻ롢
       ԲĻꤷޤ

       @param b trueϲĻ롢falseԲĻ
    */
    private void setVisibleTemplate(final boolean b) {
	clone.setVisible(b);
	cloneLabel.setVisible(b);
	choice.setVisible(b);
    }

    /**
       listProjects쥹ݥ󥹤ѡơꥹȥܥå򹹿ޤ

       @param text listProjects쥹ݥ
    */
    private void parseListProjectsResponse(final String text) {
        Document d;
        try {
            d = XMLParser.parse(text);
        } catch (DOMException e) {
            MadAngler.alert(e.getMessage());
            return;
        }
	choice.clear();
        NodeList nl = d.getElementsByTagName("project");
        for (int k = 0; k < nl.getLength(); ++k) {
            Element project = (Element) nl.item(k);
            String name = project.getAttribute("name");
	    choice.addItem(name);
        }
    }

    /**
       {@inheritDoc}
    */
    public Navigation getNavigation() {
	return navi;
    }

    /**
       {@inheritDoc}
    */
    public void setLink(final Link link) {
	listKit.cancel();
	clearText();
	navi.setLink(link);

	empty.setChecked(true);
	clone.setChecked(false);
	choice.clear();
	choice.setEnabled(false);

	Parameters params = new Parameters();
	params.add("method", "listProjects");
	listKit.sendRequest(params.toString(), loadedListener);
    }

    /**
       {@inheritDoc}
    */
    public boolean navigationClicked() {
	// OK () --> true
	// Cancel (ʤ) --> false
	return MadAngler.confirm(CANCEL_CONFIRMATION);
    }
}
